﻿Public Class Form1
    Dim img As Bitmap = Bitmap.FromFile("prof.png")
    Dim panel1Img, panel2Img As Bitmap

    Public Sub LCopy3(ByVal src As Bitmap, ByVal dest As Bitmap, ByVal srcRect As Rectangle, ByVal destRect As Rectangle)
        Debug.Assert(srcRect.Size = destRect.Size)

        Dim srcBmpData As System.Drawing.Imaging.BitmapData = src.LockBits(srcRect, Drawing.Imaging.ImageLockMode.ReadOnly, src.PixelFormat)
        Dim destBmpData As System.Drawing.Imaging.BitmapData = dest.LockBits(destRect, Drawing.Imaging.ImageLockMode.WriteOnly, dest.PixelFormat)
        Dim buffer(Math.Min(Math.Abs(srcBmpData.Stride), Math.Abs(destBmpData.Stride)) - 1) As Byte
        With Nothing
            Dim srcOffset As Integer = 0
            Dim destOffset As Integer = 0
            For i As Integer = 0 To srcBmpData.Height - 1
                System.Runtime.InteropServices.Marshal.Copy(IntPtr.Add(srcBmpData.Scan0, srcOffset), buffer, 0, buffer.Length)
                System.Runtime.InteropServices.Marshal.Copy(buffer, 0, IntPtr.Add(destBmpData.Scan0, destOffset), buffer.Length)
                srcOffset += srcBmpData.Stride
                destOffset += destBmpData.Stride
            Next
        End With
        dest.UnlockBits(destBmpData)
        src.UnlockBits(srcBmpData)

    End Sub

    Public Sub LCopy2(ByVal src As Bitmap, ByVal dest As Bitmap)
        Debug.Assert(src.Size = dest.Size)

        Dim rect As Rectangle = Rectangle.Truncate(src.GetBounds(GraphicsUnit.Pixel))

        ' src -> buffer
        Dim srcBmpData As System.Drawing.Imaging.BitmapData = src.LockBits(rect, Drawing.Imaging.ImageLockMode.ReadOnly, src.PixelFormat)
        Dim bytes As Integer = srcBmpData.Stride * rect.Height
        Dim buffer(bytes - 1) As Byte
        System.Runtime.InteropServices.Marshal.Copy(srcBmpData.Scan0, buffer, 0, bytes)
        src.UnlockBits(srcBmpData)

        ' buffer -> dest
        Dim destBmpData As System.Drawing.Imaging.BitmapData = dest.LockBits(rect, Drawing.Imaging.ImageLockMode.WriteOnly, dest.PixelFormat)
        System.Runtime.InteropServices.Marshal.Copy(buffer, 0, destBmpData.Scan0, bytes)
        dest.UnlockBits(destBmpData)

    End Sub

    Public Sub LCopy(ByVal src As Bitmap, ByVal dest As Bitmap, ByVal srcRect As Rectangle, ByVal destRect As Rectangle)
        Debug.Assert(srcRect.Size = destRect.Size)

        ' src -> buffer
        Dim srcBmpData As System.Drawing.Imaging.BitmapData = src.LockBits(srcRect, Drawing.Imaging.ImageLockMode.ReadOnly, src.PixelFormat)
        Dim destBmpData As System.Drawing.Imaging.BitmapData = dest.LockBits(destRect, Drawing.Imaging.ImageLockMode.WriteOnly, dest.PixelFormat)
        Dim bufferStride As Integer = Math.Min(Math.Abs(srcBmpData.Stride), Math.Abs(destBmpData.Stride))
        Dim bytes As Integer = bufferStride * srcRect.Height
        Dim buffer(bytes - 1) As Byte
        With Nothing
            Dim srcOffset As Integer = 0
            For bufferOffset As Integer = 0 To bytes - bufferStride Step bufferStride
                System.Runtime.InteropServices.Marshal.Copy(IntPtr.Add(srcBmpData.Scan0, srcOffset), buffer, bufferOffset, bufferStride)
                srcOffset += srcBmpData.Stride
            Next
        End With
        src.UnlockBits(srcBmpData)

        ' buffer -> dest
        With Nothing
            Dim destOffset As Integer = 0
            For bufferOffset As Integer = 0 To bytes - bufferStride Step bufferStride
                System.Runtime.InteropServices.Marshal.Copy(buffer, bufferOffset, IntPtr.Add(destBmpData.Scan0, destOffset), bufferStride)
                destOffset += destBmpData.Stride
            Next
        End With
        dest.UnlockBits(destBmpData)

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Me.panel1Img = New Bitmap(CInt(Me.img.Width * 12), CInt(Me.img.Height * 8))
        'Me.panel2Img = New Bitmap(CInt(Me.img.Width * 2), CInt(Me.img.Height * 1))
        Me.panel1Img = New Bitmap(Me.img.Width, Me.img.Height)
        Me.panel2Img = New Bitmap(Me.img.Width, Me.img.Height)

        Using g As Graphics = Graphics.FromImage(panel1Img)
            g.DrawImage(Me.img, 0, 0)
        End Using

    End Sub

    Private Sub SplitContainer1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles SplitContainer1.Paint
        Dim sz As Size = New Size(Math.Min(panel1Img.Width, panel2Img.Width), Math.Min(panel1Img.Height, panel2Img.Height))

        LCopy3(panel1Img, panel2Img, New Rectangle(0, 0, sz.Width, sz.Height), New Rectangle(0, 0, sz.Width, sz.Height))

        'LCopy2(panel1Img, panel2Img)

        'LCopy(panel1Img, panel2Img, New Rectangle(0, 0, sz.Width, sz.Height), New Rectangle(0, 0, sz.Width, sz.Height))

        'LCopy(panel1Img, panel2Img, New Rectangle(0, 0, 10, 10), New Rectangle(0, 0, 10, 10))
        'For i = 0 To 9
        '    LCopy3(panel1Img, panel2Img, New Rectangle(0, 0, sz.Width, sz.Height), New Rectangle(0, 0, sz.Width, sz.Height))
        'Next
        'For i = 0 To 9
        '    Using g As Graphics = Graphics.FromImage(panel2Img)
        '        g.DrawImage(Me.img, 0, 0)
        '    End Using
        'Next

        Using g As Graphics = SplitContainer1.Panel1.CreateGraphics()
            g.DrawImageUnscaled(Me.panel1Img, Rectangle.Truncate(Me.panel1Img.GetBounds(GraphicsUnit.Pixel)))
            g.DrawRectangle(Pens.Blue, Rectangle.Truncate(Me.panel1Img.GetBounds(GraphicsUnit.Pixel)))
        End Using
        Using g As Graphics = SplitContainer1.Panel2.CreateGraphics()
            g.DrawImageUnscaled(Me.panel2Img, Rectangle.Truncate(Me.panel2Img.GetBounds(GraphicsUnit.Pixel)))
            g.DrawRectangle(Pens.Blue, Rectangle.Truncate(Me.panel2Img.GetBounds(GraphicsUnit.Pixel)))
        End Using

    End Sub

End Class
